#import "Article.h"
#import <appkit/appkit.h>
#import "NNTP.h"

#define FULL_HEADER 0
#define NO_HEADER 1
#define SMALL_HEADER 2
#define NEWSPAPER_HEADER 3

@class MessagePart, NSString;

@interface ArticleViewControl:Object
{
    id theText;
    id nntpServer;
    id fromTextField;
    id imageView;
    id clockView;

    BOOL noArticle;
	MessagePart	*article;

    int  headerMode;	 
	BOOL rewrapping;
	BOOL signatureDetection;
	BOOL quoteItalic;
	BOOL urlZaps;
	 
	BOOL rot13;
	int	 rtfCellCounter;
}	

- init;
- awakeFromNib;
- free;
- updateText;

- (int)loadArticle:(Article *)theArticle fromGroup:(const char *)theGroup;
- displayArticleScrollUp:(BOOL)scroll;
- clear;
- saveAs:sender;
- printText:sender;
- (id)theText;

- (const char *)articleHeader;

- writeBody:(NXStream *)aStream;
- writeQuotedText:(NXStream *)aStream;

- (void)writeCompleteHeaderOntoStream:(NXStream *)stream;
- (void)writeFilteredHeaderOntoStream:(NXStream *)stream;
- (void)writeNewspaperHeaderOntoStream:(NXStream *)stream;

- (void)writeMessagePart:(MessagePart *)part ontoStream:(NXStream *)stream type:(int)stype;
- (void)writePlainText:(NSString *)string ontoStream:(NXStream *)stream type:(int)stype;
- (void)writeEnrichedText:(NSString *)string ontoStream:(NXStream *)stream type:(int)stype;
- (void)writeString:(NSString *)string ontoStream:(NXStream *)stream type:(int)stype;
- (void)writeImage:(NSData *)data withName:(NSString *)name ontoStream:(NXStream *)stream type:(int)stype;
- (void)writeAttachment:(NSData *)data withName:(NSString *)name ontoStream:(NXStream *)stream type:(int)stype;
- (void)writeURL:(NSString *)url ontoStream:(NXStream *)stream type:(int)stype;

- showHeader:sender;
- hideHeader:sender;
- smallHeader:sender;
- newspaperHeader:sender;

- (BOOL)headermodeCellEnabled:menuCell;

- rot13:sender;

@end


enum StreamType { StreamTypeASCII = 0, StreamTypeRTF = 1 };
